import { Chain, PublicClient, Transport } from "viem";
import { Dex, DexContractsV3, DexName } from "./types/dex";
import { CreateSwapRequestInput, CreateSwapRequestOutput } from "./types/smartAccount";
export declare class SmartAccountV1Provider {
    publicClient: PublicClient<Transport, Chain>;
    dex?: Dex;
    entrypoint: `0x${string}`;
    smartAccountFactory: `0x${string}`;
    constructor(publicClient: PublicClient<Transport, Chain>, entrypoint?: `0x${string}`, smartAccountFactory?: `0x${string}`, dex?: {
        [key in DexName]?: DexContractsV3;
    });
    createSwapRequest(createSwapRequestInput: CreateSwapRequestInput): Promise<CreateSwapRequestOutput>;
    getNonceForSmartAccountV1(smartAccount: `0x${string}`, dexFactory: `0x${string}`, tokens: `0x${string}`[], fee: number): Promise<bigint>;
    calculateVerificationGasLimitV1(initSmartAccount?: boolean): Promise<bigint>;
    calculateExecuteBatchGasLimit(smartAccount: `0x${string}`, dest: `0x${string}`[], value: bigint[], func: `0x${string}`[]): Promise<bigint>;
}
//# sourceMappingURL=smartAccountV1Provider.d.ts.map