import { Prettify } from "viem/_types/types/utils";
import { SmartAccountFactory } from "./smartAccount";

export type Erc4337Contracts = Prettify<{ entrypoint: `0x${string}` } & { [K in SmartAccountFactory]?: `0x${string}` }>;

export type Erc4337Chains = {
  [chainId: number]: Erc4337Contracts;
};

export type UserOperation = {
  sender: `0x${string}`;
  nonce: bigint;
  initCode: `0x${string}`;
  callData: `0x${string}`;
  callGasLimit: bigint;
  verificationGasLimit: bigint;
  preVerificationGas: bigint;
  maxFeePerGas: bigint;
  maxPriorityFeePerGas: bigint;
  paymasterAndData: `0x${string}`;
  signature: `0x${string}`;
};
